disp('  ')
disp('PLEASE WAIT: The program needs to:')  
disp('run through the model harmonic constants,')
disp('interpolate the harmonic constants,')
disp('and make the timeseries.')

ipred=1;

latw=str2num(get(h21a,'String')) + str2num(get(h21b,'String'))/60 ;
lonw=str2num(get(h24a,'String')) + str2num(get(h24b,'String'))/60 ;
lontest=get(h24c,'String');
lattest=get(h21c,'String');

if lontest=='W' | lontest=='w',
lonw=-lonw;
elseif lontest=='E' | lontest=='e',
lonw=lonw;
else
disp('Error in longitude E/W')
break
end

if lattest=='S' | lattest=='s'
latw=-latw;
elseif lattest=='N' | lattest=='n'
latw=latw;
else
disp('Error in latitude N/S')
break
end


AG=[];
%
%h and lat,lon; latu,lonu; latv;lonv are loaded in the initial program predict.m
%
% tm2 is M2 tidal period in hours
tm2=12.4206;
ts2=12.;
tn2=12.6583;
tk2=11.9672;
to1=25.8193;
tk1=23.9345;
tp1=24.0659;
tq1=26.8724;
omegat=48.*pi./[tm2 ts2 tn2 tk2 to1 tk1 tp1 tq1];
% omegat has the tidal frequencies in rad/yearday.   

% the order of frequencies is M2, S2, N2, K2, O1, K1, P1, Q1
% ui,ur,vi,vr,eli,elr are all loaded in predict.m
for iop=1:8,

if iop==1,
ui=ui1;
ur=ur1;
vi=vi1;
vr=vr1;
eli=eli1;
elr=elr1;
elseif iop==2,
ui=ui2;
ur=ur2;
vi=vi2;
vr=vr2;
eli=eli2;
elr=elr2;
elseif iop==3,
ui=ui3;
ur=ur3;
vi=vi3;
vr=vr3;
eli=eli3;
elr=elr3;
elseif iop==4,
ui=ui4;
ur=ur4;
vi=vi4;
vr=vr4;
eli=eli4;
elr=elr4;
elseif iop==5,
ui=ui5;
ur=ur5;
vi=vi5;
vr=vr5;
eli=eli5;
elr=elr5;
elseif iop==6,
ui=ui6;
ur=ur6;
vi=vi6;
vr=vr6;
eli=eli6;
elr=elr6;
elseif iop==7,
ui=ui7;
ur=ur7;
vi=vi7;
vr=vr7;
eli=eli7;
elr=elr7;
elseif iop==8,
ui=ui8;
ur=ur8;
vi=vi8;
vr=vr8;
eli=eli8;
elr=elr8;
end

% WE WILL ONLY INTERPOLATE USING DATA WITHIN 2 GRID POINTS
% note there is potentially a problem near land because land has
% a value of zero for the tide - the interpolation will work using
% this value of zero.  Therefore, results within a grid point of
% land may be suspect.
%
DEL_LON=2*(lonu(1,2)-lonu(1,1));
DEL_LAT=2*(latu(2,1)-latu(1,1));
I1=((lonw-DEL_LON) < lonu(1,:) & lonu(1,:) < (lonw+DEL_LON)) ;
I2=((latw-DEL_LAT) < latu(:,1) & latu(:,1) < (latw+DEL_LAT));
if sum(I1)>=3 & sum(I2)>=3,

lon_tmp=lonu(I2,I1);
lat_tmp=latu(I2,I1);
ur_tmp=ur(I2,I1);
ui_tmp=ui(I2,I1);
UR=interp2(lon_tmp,lat_tmp,ur_tmp,lonw,latw,'*cubic');
UI=interp2(lon_tmp,lat_tmp,ui_tmp,lonw,latw,'*cubic');
Au14=sqrt(UR.^2 + UI.^2);
Gu14=atan2(-UI,UR)*(180/pi);

I1=((lonw-DEL_LON) < lonv(1,:) & lonv(1,:) < (lonw+DEL_LON)) ;
I2=((latw-DEL_LON) < latv(:,1) & latv(:,1) < (latw+DEL_LON));
lon_tmp=lonv(I2,I1);
lat_tmp=latv(I2,I1);
vr_tmp=vr(I2,I1);
vi_tmp=vi(I2,I1); 
VR=interp2(lon_tmp,lat_tmp,vr_tmp,lonw,latw,'*cubic');
VI=interp2(lon_tmp,lat_tmp,vi_tmp,lonw,latw,'*cubic');
Av14=sqrt(VR.^2 + VI.^2);
Gv14=atan2(-VI,VR)*(180/pi); 

I1=((lonw-DEL_LON) < lon(1,:) & lon(1,:) < (lonw+DEL_LON)) ;
I2=((latw-DEL_LAT) < lat(:,1) & lat(:,1) < (latw+DEL_LAT));
lon_tmp=lon(I2,I1);
lat_tmp=lat(I2,I1);
h_tmp=h(I2,I1);
elr_tmp=elr(I2,I1);
eli_tmp=eli(I2,I1);
h14=interp2(lon_tmp,lat_tmp,h_tmp,lonw,latw,'*cubic');
Ar=interp2(lon_tmp,lat_tmp,elr_tmp,lonw,latw,'*cubic');
Ai=interp2(lon_tmp,lat_tmp,eli_tmp,lonw,latw,'*cubic');

A=100*sqrt(Ar.^2 + Ai.^2);
% minus sign below because Gary's sign convention for phase is opposite
% to the rest of the world's.
G=(180/pi)*atan2(-Ai,Ar);

% the values of Au14 and Av14 are actually transports in m^2/s.  Divide by
% the model depth and multiply by 100 to convert to current in (cm/s)
Au14=100*Au14./h14;
Av14=100*Av14./h14;
Gu14( Gu14 > 360)=Gu14( Gu14 > 360)-360;
Gv14( Gv14 > 360)=Gv14( Gv14 > 360)-360;
Gu14( Gu14 <   0)=Gu14( Gu14 < 0  )+360;
Gv14( Gv14 <   0)=Gv14( Gv14 < 0  )+360;
G( G > 360)=G( G > 360)-360;
G( G <   0)=G( G < 0  )+360;

AG=[AG;[Au14 Gu14 Av14 Gv14 A G]];
else

ipred=0;
end

end

if ipred==1,
% plot the M2 tidal ellipse on figure 1.
figure(1)
Q=axis;
xscale=Q(2)-Q(1);
yscale=Q(4)-Q(3);
scale=min([xscale yscale]);
tmptime=(0:(1/100):1.01)';
const=get(h61b,'String') ;
const_scale=str2num(get(h62b,'String')) ;
if const=='M2',
   iconst=1;
elseif const=='S2',
   iconst=2;
elseif const=='N2',
   iconst=3;
elseif const=='K2',
   iconst=4;
elseif const=='O1',
   iconst=5;
elseif const=='K1',
   iconst=6;
elseif const=='P1',
   iconst=7;
elseif const=='Q1',
   iconst=8;
else
disp(' ')
disp('Not a valid constituent, use e.g., M2 or Q1')
disp(' ')
break
end
tsx=AG(iconst,1)*cos(omegat(iconst)*tmptime - (pi/180)*AG(iconst,2));
tsy=AG(iconst,3)*cos(omegat(iconst)*tmptime - (pi/180)*AG(iconst,4));
Ux=0.1*tsx*scale/const_scale;
Uy=0.1*tsy*scale/const_scale;
plot(lonw+Ux,latw+Uy,'r')
plot(lonw+Ux(1:5),latw+Uy(1:5),'k','LineWidth',3)

plot([lonw lonw+Ux(1)],[latw latw+Uy(1)],'r')
plot([Q(2)-xscale*0.2 Q(2)-xscale*0.1 Q(2)-xscale*0.12],[Q(4)-yscale*0.1 Q(4)-yscale*0.1 Q(4)-yscale*0.08],'r')
text(Q(2)-xscale*0.2,Q(4)-xscale*0.06,[num2str(const_scale) ' cm/s'])
dz=str2num(get(h7,'String')) ;
title(['Contours in ' num2str(dz) ' m intervals; Tide prediction shows ' const ' current ellipses'])
disp('  ')
disp('Replot will clear all ellipses')
disp('  ')

figure(2)

% now pass AG to mktime
mktime

else
disp(' ')
disp('ERROR:  The point of interest is out of the range of tidal data.')
disp(' ')

end

