figure(3)
hold off
clf
figure(2)
hold off
clf
figure(1)
hold off
clf

%
%   BEGIN USER CONFIGURABLE OPTIONS
%
%
% WARNING:  The coast lines use 0 to -360 for longitude 
% initial plotting axis
A=[-169 -153 17 31];

%limits for lat,lon for which to save coastline
minlon=A(1);
maxlon=A(2);
minlat=A(3);
maxlat=A(4);
Year=2000;

if maxlon==0,
  maxlon=-0.04;
% this avoids the problem of the *.grd file ending at 359.967 rather than 360
end

% coast line filename
load ../shoreline/high_res.mat
% now have latC, lonC

%load in all the tide data and the model bathymetry - 79MB
load haw/allconsts.mat
% now have h, elr, eli, ur, ui, vr, vi defined for all 8 constituents.

%load in the lat and lon values for h, el, u, v
load haw/latlons.mat
%now have lat,lon; latu, lonu; latv; lonv

%
%   END USER CONFIGURABLE OPTIONS
%
%
% it works much faster when one chops to the minimal data one needs.

I=lonC==999;
% longitudes run from -370 to 0
% You wonder about the -370, no doubt - this is so as not
% to split Africa.
lonC(I)=nan*lonC(I);
latC(I)=nan*latC(I);
latC=latC/1000;
lonC=lonC/1000;   
I=lonC<minlon;
latC(I)=[];
lonC(I)=[];
I=maxlon<lonC;
latC(I)=[];
lonC(I)=[];
I=latC<minlat;
latC(I)=[];
lonC(I)=[];
I=maxlat<latC;
latC(I)=[];
lonC(I)=[];

lonc=lonC;
latc=latC;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
latw=[];
lonw=[];
AG=[];
F=[];
gflag=0;

plot(lonc,latc,'k')
axis('equal')
grid on
axis(A)
xlabel('Longitude')
ylabel('Latitude')
hold on

% redefine for plotting depth contours
lath=lat;
lonh=lon;
hh=h;

I=lonh(1,:)<minlon;
lath(:,I)=[];
lonh(:,I)=[];
hh(:,I)=[];
I=maxlon<lonh(1,:);
lath(:,I)=[];
lonh(:,I)=[];
hh(:,I)=[];
I=lath(:,1)<minlat;
lath(I,:)=[];
lonh(I,:)=[];
hh(I,:)=[];
I=maxlat<lath(:,1);
lath(I,:)=[];
lonh(I,:)=[];      
hh(I,:)=[];

V=0:1000:6000;
contour(lonh,lath,hh,V,'g')
axis(A)
title('Contours in 1000 m intervals')

figure(2)

h10=uicontrol('Style','Pushbutton','Position',[20 350 50 30],'String','Min Lon');
h20=uicontrol('Style','Pushbutton','Position',[75 350 50 30],'String','Max Lon');
h30=uicontrol('Style','Pushbutton','Position',[130 350 50 30],'String','Min Lat');
h40=uicontrol('Style','Pushbutton','Position',[185 350 50 30],'String','Max Lat');
h70=uicontrol('Style','Pushbutton','Position',[240 350 40 30],'String','dz (m)');
h50=uicontrol('Style','Pushbutton','Position',[350 350 100 30],'String','Year (1970-2037)');
h1=uicontrol('Style','Edit','Position',[20 310 50 30],'String',num2str(A(1)));
h2=uicontrol('Style','Edit','Position',[75 310 50 30],'String',num2str(A(2)));
h3=uicontrol('Style','Edit','Position',[130 310 50 30],'String',num2str(A(3)));
h4=uicontrol('Style','Edit','Position',[185 310 50 30],'String',num2str(A(4)));
h7=uicontrol('Style','Edit','Position',[240 310 40 30],'String','1000');
h6=uicontrol('Style','Pushbutton','Position',[285 310 50 30],'String','Replot','Callback','setaxis');
h5=uicontrol('Style','Edit','Position',[375 310 50 30],'String',num2str(Year));

h20=uicontrol('Style','Pushbutton','Position',[20  235 130 30],'String','Latitude for Prediction:');
aa=uicontrol('Style','Pushbutton','Position', [160 270  70 20],'String','Decimal Deg.');
h21a=uicontrol('Style','Edit','Position',     [160 235  70 30],'String','0');
bb=uicontrol('Style','Pushbutton','Position', [240 270  70 20],'String','Decimal Min.');
h21b=uicontrol('Style','Edit','Position',     [240 235  70 30],'String','0');
h23=uicontrol('Style','Pushbutton','Position',[20  195  130 30],'String','Longitude for Prediction:');
h24a=uicontrol('Style','Edit','Position',     [160 195  70 30],'String','0');
h24b=uicontrol('Style','Edit','Position',     [240 195  70 30],'String','0');
cc=uicontrol('Style','Pushbutton','Position', [310 270  50 20],'String','N/S;E/W');
h21c=uicontrol('Style','Edit','Position',     [325 235  20 30],'String','N');
h24c=uicontrol('Style','Edit','Position',     [325 195  20 30],'String','W');
hz0=uicontrol('Style','Pushbutton','Position',[355 195 70 20],'String','Depth is (m):') ;
hz=uicontrol('Style','Edit','Position',     [425 195  60 20],'String','-');

h22a=uicontrol('Style','Pushbutton','Position',[360 235 60 30],'String','Plot','Callback','plotpos');
h22b=uicontrol('Style','Pushbutton','Position',[425 235 60 30],'String','Graphical','Callback','gpos');

h61a=uicontrol('Style','Pushbutton','Position', [100  150 85 30],'String','Plot Ellipses for');
h61b=uicontrol('Style','Edit','Position',      [187 150  30 30],'String','M2');
h62a=uicontrol('Style','Pushbutton','Position', [225  150 85 30],'String','Ellipse Scale');
h62b=uicontrol('Style','Edit','Position',      [312 150  30 30],'String','10');


h32=uicontrol('Style','Pushbutton','Position', [20  100 100 30],'String','Start Yearday=');
h322=uicontrol('Style','Edit','Position',      [122 100  60 30],'String','');
h33=uicontrol('Style','Pushbutton','Position', [195 100 100 30],'String','End Yearday=');
h332=uicontrol('Style','Edit','Position',      [297 100  60 30],'String','');
h331=uicontrol('Style','Pushbutton','Position',[370 100  90 30],'String','Get Prediction','Callback','getpred');

h42=uicontrol('Style','Pushbutton','Position', [ 20 50 200 30],'String','Filename for harmonic constants:');
h421=uicontrol('Style','Edit','Position',      [225 50 100 30],'String','');
h422=uicontrol('Style','Pushbutton','Position',[330 50  90 30],'String','Save A,G','Callback','save_A_G');

h52=uicontrol('Style','Pushbutton','Position', [ 20 10 200 30],'String','Filename for timeseries:');
h521=uicontrol('Style','Edit','Position',      [225 10 100 30],'String','');
h522=uicontrol('Style','Pushbutton','Position',[330 10  90 30],'String','Save Timeseries','Callback','save_time');


